-- Namespace
Wuerfel = {}
Wuerfel.name = "Wuerfel"

-- init
function Wuerfel:Initialize()
	self.savedVariables = ZO_SavedVars:New("WuefelSavedVariables", 1, nil, {})
end
 
function Wuerfel.OnAddOnLoaded(event, addonName)
	-- The event fires each time *any* addon loads - but we only care about when our own addon loads.
	if addonName == Wuerfel.name then Wuerfel:Initialize()
  end
end

function split(s, delimiter)
    result = {};
    for match in (s..delimiter):gmatch("(.-)"..delimiter) do
        table.insert(result, match);
    end
    return result;
end

function wurf(ww)
	-- 
	ww = string.upper(ww)
	iModifikation = 0
	iPosW = string.find(ww, "W")
	iPosM = string.find(ww, "M")
	bOK = true
	iLaenge = string.len(ww)
	-- eingabe prüfen
	if ( iPosW == 1 ) then 
		ww = "1" .. ww
		iLaenge = iLaenge + 1
	end

	if (iLaenge == 0 or iPosW == nil)  then
		d("Syntax: /wu (/wurf) Anzahl W Seiten (max. 100). \nBeispiele: \n/wu 3W6 drei Würfe mit einem sechseitigen Würfel.\n/wu w10 ein Wurf mit einem zehnseitigen Würfel\nOptional: Parameter M -+Wert \nsubtrahiert/addiert Wert zu den Ergebnissen.\n/wu 3W10M-3\n /wu 3W10M+4")
		bOK = false
	end

	if bOK then
		sErg   = ww .. " --- "
		sTeile = split(ww, "W")
		iAnz   = tonumber( sTeile[1] ) + 1
		
		if ( iPosM ~= nil ) then
			sTeile2 = split(ww, "M")
			iModifikation = tonumber( sTeile2[2] )
			if ( iModifikation == nil ) then iModifikation = 0 end
			sTeileMaxi = split(sTeile[2], "M")
			iMaxi = tonumber( sTeileMaxi[1])
		else
			iMaxi = tonumber( sTeile[2] )
		end
		if ( iMaxi == nil ) then iMaxi = 100 end

		if (iMaxi > 100) then 
			iMaxi = 100
		end

		if (iMaxi < 1) then 
			iMaxi = 1
		end

		if ( iAnz > 21 ) then
			iAnz = 21
		end

		if ( iAnz < 1 ) then
			iAnz = 2
		end

		math.randomseed(os.time())
		wurf = 0
		wurfe = 0
		if ( iAnz > 0 and iMaxi > 0 ) then
			for i = 1, iAnz, 1
			do
				repeat
					wurf = math.random(1, iMaxi)
				until ( wurf <= iMaxi )
				wurfe = wurf + iModifikation
				if ( i > 1 ) then 
					sErg = sErg .. i-1 .. ". Wurf: " .. wurfe .. " --- "
					--d(wurfe)
				end
			end
		else
			d("Syntax: \n/wu 1w10 \noder \n/wu 3w6\n1. Teil = Anzahl der Würfel, dann w oder W und der letzte Teil gibt die Seiten des Würfels an!")
		end

		if ( string.len(sErg) > 0 ) then
			if ( iModifikation ~= 0 ) then sErg = sErg .. " Modifikation = " .. iModifikation end
			ZO_ChatWindowTextEntryEditBox:SetText(sErg)
			--d(sErg)
		end
	end
end

SLASH_COMMANDS["/wu"] = wurf
SLASH_COMMANDS["/wurf"] = wurf